<?php
/**
*	Collect data from G+
*	Copyright (C) 2011  Arun
*	http://www.skipser.com
*
*/
//date_default_timezone_set('Asia/Calcutta');
class googleBadge
{
	// The base g+ URL
	public $gplus_url = 'http://plus.google.com/';

	// set a plausible user agent
	public $user_agent = 'Mozilla/5.0 (X11; Linux x86_64; rv:5.0) Gecko/20100101 Firefox/5.0';

	// how many hours to cache for
	public $cache_time = '14400'; // 4*60*60
	public $tmpl_time = '86400';  // 24*60*60

	// cache file name
	public $cache_file = '';

	//regexp file name
	public $regexp_file = '';

	// constructor
	function __construct($id = '', $debug='')
	{
		if (!empty($id) && is_numeric($id))
		{
			// build our google+ url
			$this->regexp_filever = "1.6";

			$this->url = $this->gplus_url . $id.'/about';
			$this->regexpurl = "http://www.skipser.com/test/gplus-badge/regexp_".$this->regexp_filever.".txt";
			$this->user_id = $id;
			$this->debug = $debug;
		}
	}

	// main handler function, call it from your script
	public function googleBadge() {
		if($this->debug === 'true') {
			echo ">>>>".$_SERVER['REQUEST_URI']."<br/>";
		}
		$valid_cache=false;
		if( $this->isValidCache()) {
			if($this->debug === 'true') {
				echo ">>>>Got valid cache<br/>";
			}
			$valid_cache=true;
			$html=$this->getDataInCache();
			if((is_null($html['count']) || empty($html['count'])) && (is_null($html['name']) || empty($html['name'])) && (is_null($html['img']) || empty($html['img'])) && (is_null($html['url']) || empty($html['url']))) {
				$valid_cache=false;
			}
			if($this->debug === 'true') {
				echo ">>>>Got cache data - ".$html['name']." : ".$html['img']." : ".$html['count']."<br/>";
			}
			$this->getBadgeTmpls();
			//In case the user has just updated the version, regexps or template might need an instant refresh.
			if($this->regexp_filever != $this->regexpver) {
				if($this->debug === 'true') {
					echo ">>>>Got invalid regexp version : ".htmlentities($this->regexp_filever).", ".htmlentities($this->regexpver)."<br/>";
				}
				$valid_cache = false;
			}
		}
		if($valid_cache == false) {
			if($this->debug === 'true') {
				echo ">>>>Got invalid cache<br/>";
			}
			$this->getBadgeTmpls();
			//In case the user has just updated the version, regexps or template might need an instant refresh.
			if($this->regexp_filever != $this->regexpver) {
				if($this->debug === 'true') {
					echo ">>>>Refreshing regexps as version is old.<br/>";
				}
				$this->refreshRegexp();
				$this->getBadgeTmpls();
			}

			//Just update the cache once so we don't have a lot of simultaneous cache updates.
			$html=$this->getDataInCache();
			if($this->debug === 'true') {
				echo ">>>>Corrupted cache data - ".$html['name']." : ".$html['img']." : ".$html['count']."<br/>";
			}
			$this->updateCache($html);
			if($this->debug === 'true') {
				echo ">>>>Fixed cache data - ".$html['name']." : ".$html['img']." : ".$html['count']."<br/>";
			}
			
			$html=$this->getDataForCache();
			if($this->debug === 'true') {
				echo ">>>>Got data - ".$html['name']." : ".$html['img']." : ".$html['count']."<br/>";
			}
			if(is_null($html['count']) || empty($html['count']) || is_null($html['name']) || empty($html['name']) || is_null($html['img']) || empty($html['img']) || is_null($html['url']) || empty($html['url'])) {
				if($this->debug === 'true') {
					echo ">>>>Got corrupted cache after first try<br/>";
				}
				$this->refreshRegexp();
				$html=$this->parseHtml();
				if(is_null($html['count']) || empty($html['count']) || is_null($html['name']) || empty($html['name']) || is_null($html['img']) || empty($html['img']) || is_null($html['url']) || empty($html['url'])) {
					if($this->debug === 'true') {
						echo ">>>>Got corrupted cache after second try<br/>";
					}
					$html=$this->getDataInCache();
					$this->updateCache($html);
				}
				else {
					if($this->debug === 'true') {
						echo ">>>>Got good cache after second try - ".$html['name']." : ".$html['img']." : ".$html['count']."<br/>";
					}
					$this->updateCache($html);
				}
			}
			else {
				if($this->debug === 'true') {
					echo ">>>>Got good cache after first try - ".$html['name']." : ".$html['img']." : ".$html['count']."<br/>";
				}
				$this->updateCache($html);
			}
		}
		return $html;
	}

	//Checks if our cache is valid. Returns true or false.
	protected function isValidCache() {
		$file = $this->cache_file;
		$regexpfile = $this->regexp_file;
		$cache_time =  $this->cache_time;
		$tmpl_time = $this->tmpl_time;
		$got_init=false;

		if(! file_exists($file)) {
			$this->updateCache(array('id' => '', 'count' => '', 'name' => '', 'img' => '', 'url' => ''));
			$got_init=true;
		}

		if(! file_exists($regexpfile)) {
			$this->refreshRegexp();
		}
		else if (time() - $tmpl_time > filemtime($regexpfile)) {
			$this->refreshRegexp();
		}

		if($got_init == true) {
			return false;
		}

		// if we have a cache file and it's within our expiry time
		if (time() - $cache_time < filemtime($file)) {
			return true;
		}
		else {
			return false;
		}
	}

	//Nullifies content in cache.
	protected function nullifyCache() {
		$file = $this->cache_file;
		$this->updateCache(array('id' => '', 'count' => '', 'name' => '', 'img' => '', 'url' => ''));
	}

	//Reads cache and returns array.
	protected function getDataInCache() {
		$file = $this->cache_file;

		//open cached file
		$handle = fopen($file, "r");
		//read it
		$data = fgets($handle);
		//close it
		fclose($handle);

		// json decode, put into array and return
		return get_object_vars(json_decode($data));
	}

	//Updates cache with passed array.
	protected function updateCache($html) {
		$file = $this->cache_file;

		// json encode the data
		$json = json_encode($html);

		// open the file
		$handle = fopen($file, 'w');

		// write data to file
		fwrite($handle, $json);

		// close file
		fclose($handle);
	}

	//Use the current regexp file to retrieve data for cache from G+
	protected function getDataForCache() {
		$this->html = '';
		$data='';
		if($this->debug === 'true') {
			echo ">>>>From getDataForCache start <br/>";
		}
		/*
		*	if safe mode or open_basedir is set, skip to using file_get_contents
		*	(fixes "CURLOPT_FOLLOWLOCATION cannot be activated" curl_setopt error)
		*/
		if(ini_get('safe_mode') || ini_get('open_basedir')) {
			// do nothing (will pass on to getPafeFile/get_file_contents as isset($curlHtml) will fail)
		}
		else {
			// load the page
			if($this->debug === 'true') {
				echo ">>>>Starting getPageCurl <br/>";
			}
			$this->html = $this->getPageCurl($this->url);
			if($this->debug === 'true') {
				echo ">>>>Ending getPageCurl <br/>";
			}

			// parse the returned html for the data we want
			$data = $this->parseHtml();
		}

		// see if curl managed to get data
		// if not, try with get_file_contents
		if (isset($data) && !empty($data['name']) && !empty($data['count']) && !empty($data['img'])) {
		}
		else {
			if($this->debug === 'true') {
				echo ">>>>Stariting getPageFile <br/>";
			}
			// try loading with file_get_contents instead
			$this->html = $this->getPageFile($this->url);
			if($this->debug === 'true') {
				echo ">>>>Ending getPageFile <br/>";
			}

			// parse
			$data = $this->parseHtml();
		}
		if($this->debug === 'true') {
			echo ">>>>From getDataForCache end <br/>";
		}
		return $data;
	}

	// use curl to load the page
	protected function getPageCurl($url) {
		// initiate curl with our url
		$this->curl = curl_init($url);

		// set curl options
		curl_setopt($this->curl, CURLOPT_HEADER, 0);
		curl_setopt($this->curl, CURLOPT_USERAGENT, $this->user_agent);
		curl_setopt($this->curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($this->curl, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($this->curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($this->curl, CURLOPT_SSL_VERIFYHOST, false);

		// execute the call to google+
		$html = curl_exec($this->curl);

		curl_close($this->curl);

		return $html;
	}

	// use file_get_contents to load the page
	protected function getPageFile($url) {
		// empty the html property (although it's probably empty anyway if we're here)
		$html = '';

		// get the data
		$html = file_get_contents($url);
		if($this->debug === 'true') {
			echo htmlentities($html);
			echo "<br/>";
		}

		return $html;
	}

	// parses through the returned html
	protected function parseHtml() {
		$this->html=substr($this->html, 0, strpos($this->html, $this->htmlshortnerplaceholder));

		// parse the html for the user's name and image
		if($this->debug === 'true') {
			echo ">>>>Name regexp - ".htmlentities($this->nameregexp).", ".$this->nameregexp_group."<br/>";
		}
		preg_match($this->nameregexp, $this->html, $matches);
		if (isset($matches) && !empty($matches)) {
			$name = $matches[$this->nameregexp_group];
			if($this->debug === 'true') {
				echo ">>>>Got name from regexp - ".htmlentities($this->nameregexp).", ".$name."<br/>";
			}
		}
		else {
			$name = '';
		}
		$img='https://plus.google.com/s2/photos/profile/'.$this->user_id;

		// Follower count and follower images.
		if($this->debug === 'true') {
			echo ">>>>Circles regexp - ".htmlentities($this->circlesregexp).", ".$this->circlesregexp_group."<br/>";
		}
		preg_match($this->circlesregexp, $this->html, $matches);
		if (preg_last_error() == PREG_BACKTRACK_LIMIT_ERROR) {
			if($this->debug === 'true') {
				print 'Backtrack limit was exhausted!<br/>';
			}
		}
		if (isset($matches) && !empty($matches)) {
			$circles = $matches[$this->circlesregexp_group];
			if($this->debug === 'true') {
				echo ">>>>Got circles from regexp - ".htmlentities($this->circlesregexp_group).", ".$circles."<br/>";
			}
		}
		else {
			$circles = 0;
		}
		if($this->debug === 'true') {
			echo ">>>>Out of circles regexp<br/>";
		}

		// put the data in an array
		$return = array('id' => $this->user_id, 'count' => $circles, 'name' => $name, 'img' => $img, 'url' => $this->url);

		return $return;
	}

	//Refreshes content of regexp file from skipser.
	//This is to ensure any modifications are applied.
	protected function refreshRegexp() {
		$file = $this->regexp_file;
		$regexp = '';
		$gotvaliddata=false;
		if(ini_get('safe_mode') || ini_get('open_basedir')) {
			// do nothing (will pass on to getPafeFile/get_file_contents as isset($curlHtml) will fail)
		}
		else {
			// load the page
			$regexp=$this->getPageCurl($this->regexpurl);
		}

		preg_match('/Google\+ badge field regexps/s', $regexp, $matches);
		if (isset($matches) && !empty($matches)) {
			//Curl didn't manage to get the data. Try with get_file_contents.
		}
		else {
			// try loading with file_get_contents instead
			$regexp = $this->getPageFile($this->regexpurl);
		}

		// open the file
		$handle = fopen($file, 'w');

		// write data to file
		fwrite($handle, $regexp);

		// close file
		fclose($handle);
	}

	protected function getBadgeTmpls() {
		$file = $this->regexp_file;
		$this->nameregex = '';
		$this->htmlshortnerplaceholder='';
		//$this->imgregexp = '';
		$this->circlesregexp = '';
		$this->fullbadgetmpl='';

		//read it
		$handle = fopen($file, "r");

		//Get the regexps for each data.
		$index = 0;
		while (($line = fgets($handle)) !== false) {
			if($index == 0) {
				$this->regexpver = preg_replace('/Google\+ badge field regexps - /', '', trim($line));
			}
			elseif($index == 1) {
				$this->htmlshortnerplaceholder = trim($line);
			}
		    elseif($index == 2) {
				$this->nameregexp = trim($line);
			}
			elseif($index == 3) {
				$this->circlesregexp = trim($line);
			}
			elseif($index == 4) {
				$this->fullbadgetmpl = trim($line);
			}
			elseif($index == 5) {
				$this->nameregexp_group = trim($line);
			}
			elseif($index == 6) {
				$this->circlesregexp_group = trim($line);
			}
			$index++;
		}

		fclose($handle);

	}
	function int_divide($x, $y) {
	    if ($x == 0) return 0;
	    if ($y == 0) return FALSE;
	    $result = $x/$y;
	    $pos = strpos($result, '.');
	    if (!$pos) {
	        return $result;
	    } else {
	        return (int) substr($result, 0, $pos);
	    }
	}
	function normalise_jsonstr($json) {
		$current_encoding = mb_detect_encoding($json, 'auto');
		$json = iconv($current_encoding, 'UTF-8', $json);
		$json=preg_replace('/, *,/', ',"",' , $json);
		$json=preg_replace('/, *,/', ',"",' , $json);
		$json=preg_replace('/\[ *,/', '["",' , $json);
		$json=preg_replace('/, *\]/', ',""]' , $json);
		return $json;
	}
	function get_from_jsonobj($obj, $arr) {
		$size = count($arr);
		$val = $obj;
		for($i=0; $i<$size; $i++) {
			$val=$val[$arr[$i]];
		}
		return $val;
	}
}
?>